#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "coordc.c"
int    n1,n2;                       
double pi,cx,cy,sphi,cphi,s0,ut,cosdc;
double w_de, epoch;                
double a8[8],b8[6];                 
char   head[72][80],c1[14],c2[14];
FILE   *fp;
char   f1[60];
int    iy,im,id,itype,match;
int    onum;                   
float  map[4096*4072];             
double rms,sky,seeing,skyrms;
double xa,xd,xi,xn;                  // dummy
double oac,odc;
double oldac,olddc;

#define nn 29000
int    nstar,nu4;
double starx[nn],stary[nn],starv[nn], aa[nn],dd[nn];
short  ee[nn],pr2[nn],pd2[nn];                // proper motion 
int    uno[nn];                               // number of u4
double a_c,d_c,up_a,dn_a,up_d,dn_d;  // always 2000.0,  for u4
double ha;
int    u4index[240][900];     
float  dra=0,dde=0;                  // for bok center adjust, in arcmin
int    ipic=0;
float  a35[35],b35[35];

getstar(kk)
int *kk;
{
  char a[80];
  int i,j,k,ip=0;
  double z,z16=16.;                       // if more star, z16=16,15,14
  double edg;
  system("cp /vega2/rhbin/default.sex .");
  system("cp /vega2/rhbin/default.conv .");
  system("cp /vega2/rhbin/default.param .");
  sprintf(a,"sex %s",f1); system(a);     // max is nn
  edg=120.; 
l05:
  fp=fopen("test.cat","r");
  k=0; ip++;
l10:
  fgets(a,80,fp); if(feof(fp))goto l20;
  if(a[0]=='#')goto l10;
  sscanf(a,"%lf %lf %lf",&starv[k],&starx[k],&stary[k]);
  if(starv[k]>z16)goto l10;
  if(starx[k]<edg || starx[k]>=n1-edg )goto l10;
  if(stary[k]<edg || stary[k]>=n1-edg )goto l10;
  k++;  
  if(k<nn)goto l10;                           
  else if(ip<3){ z16-=1.; fclose(fp);  goto l05; }
l20:
  if(k<50 && ip<2){ z16+=2.0; fclose(fp); goto l05; }
  fclose(fp);
  sortx3(starv,starx,stary,k);
  *kk=k;
}

sortx3(a,b,c,n)
double *a,*b,*c; int n;
{
  int i,j,k=2,ii; double a1,b1,c1;
  while(k<n)k*=2; k=(3*k)/4-1; if(n<k)k=n;
l20: k/=2; 
  for(ii=0;ii<n-k;ii++){
    i=ii; j=i+k; if(a[i]<=a[j])continue;
    a1=a[j]; b1=b[j]; c1=c[j];
l40:
    a[j]=a[i]; b[j]=b[i]; c[j]=c[i];
    j=i; i-=k; if(i>=0 && a[i]>a1)goto l40;
    a[j]=a1; b[j]=b1; c[j]=c1;
  } if(k>1)goto l20;
}

double  fjd(int iy,int im,int id)
{
  int i,j;
  i=(int)((im+9)*0.09);
  i=(int)((i+iy-1900)*1.75+0.01);
  j=(int)(30.56*im);
  j=(iy-1950)*367+id+j-i;
  return(2433338.5+j);
}

getpar()
{
  int    i,j,ipos;
  double d1,d2,d,x,xk,x1;
  char   c[21];
  ipos=indexpos(head,"SKYADU  ",72);
  if(ipos!=72)sscanf(&head[ipos][12],"%lf",&sky); else sky=0.;
  ipos=indexpos(head,"DATE-OBS",72);
  strncpy(c,&head[ipos][10],20); for(i=0;i<21;i++)if(c[i]<'0'||c[i]>'9')c[i]=32;
  sscanf(c,"%d %d %d",&iy,&im,&id);
  if(iy<1900){ i=id; id=iy; iy=i+2000; if(iy>2050)iy-=100; }  // for SMT data
  ipos=indexpos(head,"TIME-OBS",72);
  if(ipos==72)ipos=indexpos(head,"TIME    ",72);              // for SMT time
  strncpy(c,&head[ipos][10],20); for(i=0;i<21;i++)if(c[i]<'.'||c[i]>'9')c[i]=32;
  sscanf(c,"%d %d %lf",&i,&j,&x);
  ipos=indexpos(head,"EXPTIME ",72);
  if(ipos==72)ipos=indexpos(head,"EXPOSURE",72);              // for SMT exp
  sscanf(&head[ipos][19],"%lf",&xk);
  ut=i+j/60.+x/3600.+xk/7200.;
  d1=fjd(1992,12,31);
  d2=(6+38/60.+40.1954/3600.)/24.;
  x1=-(111.+36.0/60.+1.6/3600.)/15.;       // 111:36:01.61 lamda of BOK
  d=fjd(iy,im,id);
  d=(d-d1)*1.0027379093+d2;
  j=d; d-=j;
  s0=d*24.+x1+ut*1.0027379093;
  ipos=indexpos(head,"RA      ",72);
  strncpy(c,&head[ipos][10],20); for(i=0;i<21;i++)if(c[i]<'.'||c[i]>'9')c[i]=32;
  sscanf(c,"%d %d %lf",&i,&j,&x);
  d1=i+j/60.+x/3600.;
  ipos=indexpos(head,"DEC     ",72);
  strncpy(c,&head[ipos][10],20); xk=1.; for(i=0;i<21;i++)if(c[i]=='-')xk=-1.;
                                 for(i=0;i<21;i++)if(c[i]<'.'||c[i]>'9')c[i]=32;
  sscanf(c,"%d %d %lf",&i,&j,&x);
  d2=xk*(i+j/60.+x/3600.);
  ipos=indexpos(head,"EPOCH   ",72);
  if(ipos==72){ printf("I cannot found EPOCH !!!\n"); exit(0); }
  sscanf(&head[ipos][12],"%lf",&epoch);
  astprs2(d1,d2,epoch,&a_c,&d_c,2000.0);

  ipos=indexpos(head,"RA-OBS  ",72);
  strncpy(c,&head[ipos][10],20); for(i=0;i<21;i++)if(c[i]<'.'||c[i]>'9')c[i]=32;
  sscanf(c,"%d %d %lf",&i,&j,&x);
  oac=i+j/60.+x/3600.;
  ipos=indexpos(head,"DEC-OBS ",72);
  strncpy(c,&head[ipos][10],20); xk=1.; for(i=0;i<21;i++)if(c[i]=='-')xk=-1.;
                              for(i=0;i<21;i++)if(c[i]<'.'||c[i]>'9')c[i]=32;
  sscanf(c,"%d %d %lf",&i,&j,&x);
  odc=xk*(i+j/60.+x/3600.);
  ipos=indexpos(head,"INSTRUME",72);
  w_de=30.;
  x=(31.+57./60.+46.5/3600.)*cy;            // 31:57:46.5 BOK latitude
  sphi=sin(x); cphi=cos(x);
}

fgsc(rc,dc,w_de)
double rc,dc,w_de;
{
  double hw_de,hw_al,x,y,z;
  int    i,j,k1,k2;
  short  s;
  fp=fopen("/UCAC4/u4index2.unf","rb");
  fread(u4index,900*240,4,fp); fclose(fp);
  hw_de=w_de/120.;
  up_d=dc+hw_de;    
  dn_d=dc-hw_de;
  x=cos(up_d*cy);   y=cos(dn_d*cy);  z=x; if(z>y)z=y;
  hw_al=hw_de/z/15.; // if(hw_al>12.)hw_al=12.;
  up_a=rc+hw_al;    
  if(up_a>=24.)up_a-=24.;
  dn_a=rc-hw_al;      if(dn_a<  0.)dn_a+=24.;
  cosdc=cos(dc*cy); if(cosdc<.05)cosdc=.05;
  nu4=0;
  k1=(dn_d+90.)*5.+1.;  k2=(up_d+90.)*5.+0.9999;
  for(i=k1;i<=k2;i++) cat_u4(i); 
  for(i=0;i<nu4-1;i++)for(j=i+1;j<nu4;j++){
    x=ee[i]; if(x<0.)x=-x;
    y=ee[j]; if(y<0.)y=-y;
    if(x>y){
      x=aa[i]; aa[i]=aa[j]; aa[j]=x;
      x=dd[i]; dd[i]=dd[j]; dd[j]=x;
      s=ee[i]; ee[i]=ee[j]; ee[j]=s;
    }
  }
}

//#pragma pack(1)
struct {
 int   ra,dc; short magm,maga; char  sigmag,objt,cdf;   // 15 
 char  s5[5];                                           //  5 
 short cepra,cepdc; short pr2, pd2; char  s2[2];        // 10
 int a1; short j_m,h_m,k_m; char icqflg[3],e2mpho[3];   // 16
 double ap1,ap2;                                        // 16
 int icf; char leda,x2m; int  rnm; short zn2; int  rn2; // 16
} u;
cat_u4(i360)
int i360;
{
  double x1,x2, ra,dc,mas,xa,xd,xmag;
  short  ix,iy;
  char   f1[30], c1[14],c2[14];
  int    i,j,k,i87;

  mas=3600000.;    i=i360-1;
  x1=dn_a; x2=up_a;  if(x2<x1)x2+=24.;
  j=x1*10.; j--; if(j<0)k=0; else  k=u4index[j][i];
  i87=0; if(up_d>87. || dn_d<-87.){ i87=1;  k=0; }
  sprintf(f1,"/UCAC4/z%03d\0",i360);

  fp=fopen(f1,"rb");
  if(fp==0){ printf("datafile not found! %s\n",f1); exit(0); }
l05:
  fseek(fp,k*78,0);
l10:
  fread(&u,1,78,fp);   if(feof(fp))goto l20;
  k++;
  ra=u.ra/mas/15.;
  if(ra>x2 && i87==0)goto l100;               // normal exit
  if(ra<x1 && i87==0)goto l10;
  dc=(u.dc-mas*90.)/mas;  if(dc<dn_d || dc>up_d)goto l10;
  ra+=u.pr2*.1*(epoch-2000.0)/mas/15./cosdc;
  dc+=u.pd2*.1*(epoch-2000.0)/mas;
  aa[nu4]=ra;
  dd[nu4]=dc;
  ee[nu4]=u.magm;    
  nu4++; if(nu4==nn)nu4--;
  goto l10;
l20:
  x1-=24.; x2-=24.;  k=0;
  if(i87==0)goto l05;
l100:
  fclose(fp);
}

astprs2(ra1, dc1, ep1, ra2, dc2, ep2)   // RA in hour, DEC in degree
double  ra1,dc1,ep1,*ra2,*dc2,ep2;      // only ra2,dc2   is output
{
  double r0[3],r1[3],p[3][3],arc;
  double r2,d2;

  arc=45./atan(1.);
  *ra2=ra1; *dc2=dc1;
  if(ep1 == ep2)return;
  r2 =ra1*15./arc; d2 =dc1/arc;
  r0[0]=cos(r2)*cos(d2); r0[1]=sin(r2)*cos(d2); r0[2]=sin(d2);
  if(ep1 != 2000.){
    astrox(ep1, p);
    r1[0] = p[0][0] * r0[0] + p[0][1] * r0[1] + p[0][2] * r0[2];
    r1[1] = p[1][0] * r0[0] + p[1][1] * r0[1] + p[1][2] * r0[2];
    r1[2] = p[2][0] * r0[0] + p[2][1] * r0[1] + p[2][2] * r0[2];
    r0[0] = r1[0]; r0[1] = r1[1]; r0[2] = r1[2];
  }
  if(ep2 != 2000.){
    astrox(ep2, p);
    r1[0] = p[0][0] * r0[0] + p[1][0] * r0[1] + p[2][0] * r0[2];
    r1[1] = p[0][1] * r0[0] + p[1][1] * r0[1] + p[2][1] * r0[2];
    r1[2] = p[0][2] * r0[0] + p[1][2] * r0[1] + p[2][2] * r0[2];
    r0[0] = r1[0];    r0[1] = r1[1];    r0[2] = r1[2];
  }
  *ra2  = atan2(r0[1], r0[0])/15.*arc;
  *dc2 = asin(r0[2])*arc;
  if(*ra2<0)*ra2+=24.;
}

astrox (epoch, p)
double epoch,p[3][3];
{
  double t,a,b,c,ca,cb,cc,sa,sb,sc,arc;
  arc=45./atan(1.);
  astjuy(epoch,&t);
  t = (t - 2451545.0) / 36525.;
  a = t * (0.6406161 + t * (0.0000839 + t * 0.0000050));
  b = t * (0.6406161 + t * (0.0003041 + t * 0.0000051));
  c = t * (0.5567530 - t * (0.0001185 + t * 0.0000116));
  ca = cos (a/arc);
  sa = sin (a/arc);
  cb = cos (b/arc);
  sb = sin (b/arc);
  cc = cos (c/arc);
  sc = sin (c/arc);
  p[0][0] = ca * cb * cc - sa * sb;
  p[1][0] = -sa * cb * cc - ca * sb;
  p[2][0] = -cb * sc;
  p[0][1] = ca * sb * cc + sa * cb;
  p[1][1] = -sa * sb * cc + ca * cb;
  p[2][1] = -sb * sc;
  p[0][2] = ca * sc;
  p[1][2] = -sa * sc;
  p[2][2] = cc;
}

astjuy (epoch,t)
double epoch,*t;
{
  double jd;
  int year,centuy;
  year = epoch - 1;
  centuy = year / 100;
  jd =1721425.5+365.*year-centuy+ year/4 + centuy/4;
  year=epoch;
  *t= jd + (epoch - year) * 365.25;
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

standc(rc,dc,ra,de,xi,xn)
double rc,dc,ra,de,*xi,*xn;
{
  double sd,cd,td,co,tmp;
  sd=sin(dc);
  cd=cos(dc);
  td=tan(de);
  co=cos(ra-rc);
  tmp=sd*td+cd*co;
  *xi=sin(ra-rc)/tmp;
  *xn=(cd*td-sd*co)/tmp;
}

astand(rc,dc,xi,xn,ra,de)
double rc,dc,xi,xn,*ra,*de;
{
  double cd,td;
  cd=cos(dc);
  td=tan(dc);
  *ra=atan(xi/cd/(1.-xn*td));
  *de=atan((xn+td)*cos(*ra)/(1.-xn*td));
  *ra+=rc;
  cd=(*de)-dc; if(cd<0.)cd=-cd;
  if(cd>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

main_job()
{
  char   c3[3];
  char   ns1[50],dis[60];
  double x9[99],y9[99];
  double sx[4],sy[4];
  int    i,j,k=0;
  float  x,y,u,v;
  int    ipp=0;

  a_c=oac+(dra/900.)/cos(odc*cy);
  d_c=odc+(dde/60.);
  a8[0]=-0.2193e-05;     // in case, not use bok == 48
  a8[1]= 0.2184e-07;
  a8[2]= a8[1];
  a8[3]=-a8[0];
  a8[4]= 0.4457e-02;
  a8[5]=-0.4475e-02;
  k=indexpos(head,"CCD_NO: ",72);
  k=head[k][29]-48;
  u=0.018557/cos(d_c*cy);
  v=0.265689;
  x=1.33/3600./cos(d_c*cy);
  y=27./3600.;
  if(k==2){ a_c+=u; d_c-=v; }
  if(k==3){ a_c-=u; d_c+=v; }
  if(k==1){ a_c+=(u+x); d_c+=(v-y); }
  if(k==4){ a_c-=(u+x); d_c-=(v-y); }
  a8[6]=oldac=a_c*cx; a8[7]=olddc=d_c*cy;

  fgsc(a_c,d_c,w_de*1.1);
l15:  
  ipp++;
  rms=55.; match=kgsc(99);
  if(match==0){
    shift_c();
    if(match<5){ if(ipp==2)return(0);  goto l15; }
  }
  a_c=a8[6]/cx; d_c=a8[7]/cy;
  fgsc(a_c,d_c,w_de);

  rms=5.;  match=kgsc(0);
  if(match==0)return(0); 
  if(a8[6]<0.)a8[6]+=pi+pi;
  return(1);
}

double xx[nn],yy[nn],vv[nn],wa[nn],wd[nn],gr[nn],gd[nn],xixn[nn][2],xy[nn][2];
short  zz[nn];
char   xyw[nn];
int kgsc(kk)
int kk;
{
  int i,j,k,m,l,n12,nu,ns,iz;
  double x,z1,z2,z,sig,sigma;
  float  fpeek,fsigma;
  ns=nstar; nu=nu4; if(kk>0)ns=nu=kk;
  if(nstar<kk)ns=nstar; if(nu4<kk)nu=nu4;
//  printf("ccd_star:%d  u4_star:%d\n",ns,nu);
  for(i=0;i<ns;i++){ xx[i]=starx[i]; yy[i]=stary[i]; vv[i]=starv[i]; xyw[i]=0;}
  n12=10; if(ns<=kk)n12=6;
  xytoad(a8,b8);
  for(i=0;i<nu;i++){
    xa=aa[i]*cx; xd=dd[i]*cy;
    standc(a8[6],a8[7],xa,xd,&xi,&xn);
    wa[i]=b8[0]*xi+b8[2]*xn+b8[4];
    wd[i]=b8[1]*xi+b8[3]*xn+b8[5];
  }

  for(i=0;i<nu;i++){
    x=rms;
    for(j=0;j<ns;j++){
      z1=wa[i]-xx[j];
      z2=wd[i]-yy[j];
      z=sqrt(z1*z1+z2*z2);
      if(z<x){ k=j; x=z; }
    }
    if(x!=rms){ xyw[k]=1; gr[k]=aa[i]; gd[k]=dd[i]; }
  }
  j=0;
  for(i=0;i<ns;i++)if(xyw[i]){
    xy[j][0]=xx[j]=xx[i];
    xy[j][1]=yy[j]=yy[i];
             vv[j]=vv[i];
    gr[j]=gr[i]; gd[j]=gd[i];
    xyw[j]=1;
    xa=gr[j]*cx; xd=gd[j]*cy;
    standc(a8[6],a8[7],xa,xd,&xi,&xn);
    xixn[j][0]=xi;
    xixn[j][1]=xn;
    j++;   
  }
  l=j;
  k=0;
l151:
  if(l-k<n12)return(0);
  k++;
  plate(xixn,xy,xyw,l,a8,3);
  iz=m=0; sig=z=0.;
  for(i=0;i<l;i++){
    xi=a8[0]*xy[i][0]+a8[2]*xy[i][1]+a8[4];
    xn=a8[1]*xy[i][0]+a8[3]*xy[i][1]+a8[5];
    astand(a8[6],a8[7],xi,xn,&xa,&xd);
    xa/=cx; xd/=cy;
    sigma=gr[i]-xa; if(sigma<0.)sigma=-sigma;
    if(sigma>20.)sigma-=24.;
    sigma=sigma*15.*cos(a8[7]);
    sigma=sigma*sigma+(gd[i]-xd)*(gd[i]-xd);
    sigma=sqrt(sigma)*3600.;
    if(xyw[i]==1){                           // xyw=0.1.-1
      zz[iz++]=sigma*10.+0.5;
      if(sigma>z){ z=sigma; j=i; }
      sig+=sigma; m++;
    }
  }
  x=sig/m;
//  if(x>6. && k>9)return(0);
  if(z>5.0){ xyw[j]=-xyw[j]; goto l151; }    // coord RMS precison   ???
  k=-k;
  z=n1/2.; 
  z2=n2/2.; 
  xi=a8[0]*z+a8[2]*z2+a8[4];              // new center RA,DEC
  xn=a8[1]*z+a8[3]*z2+a8[5];              // center X,Y is n/2
  astand(a8[6],a8[7],xi,xn,&xa,&xd);     // due to history reason, =(n+1)/2
  a8[6]=xa; a8[7]=xd;
  for(i=0;i<l;i++){
    xa=gr[i]*cx;
    xd=gd[i]*cy;
    standc(a8[6],a8[7],xa,xd,&xi,&xn);
    xixn[i][0]=xi;
    xixn[i][1]=xn;
  }
  if(k<0)goto l151;
  if(iz>20){
    white_black(zz,1,iz,&fpeek,&fsigma);
    x=fpeek*0.1;
  } else return (0);
  printf("\nBy using %d stars to calculate 8 ceof, RMS:%6.2lf arcsec\n",iz,x);
  rms=x;
  return(iz);
}

double xmedian(a,m)
double *a; int m;
{
  int i,j;
  double x;
  for(i=0;i<m-1;i++)for(j=i+1;j<m;j++)if(a[i]>a[j]){
    x=a[i]; a[i]=a[j]; a[j]=x;
  }
  j=m/2;
  if(m%2)return(a[j]);
  else return((a[j-1]+a[j])/2.);
}

double adx[99],ady[99],czr1[99],czr2[99],stx[99],sty[99];
int    cz1[99],cz2[99];
short  w[199];
shift_c()              // use bright 30 object
{
  int    i,j,ip=0,m,n30;
  double r,rr;
  float peak,s;
  n30=99;
  for(i=0;i<n30;i++){                // 2048_7
    stx[i]=starx[i]; sty[i]=stary[i];
  }
l5:
  xytoad(a8,b8);
  for(i=0;i<n30;i++){
    xa=aa[i]*cx;
    xd=dd[i]*cy;
    standc(a8[6],a8[7],xa,xd,&xi,&xn);
    adx[i]=b8[0]*xi+b8[2]*xn+b8[4];
    ady[i]=b8[1]*xi+b8[3]*xn+b8[5];
  }
  m=0;
  for(i=0;i<n30;i++){
    r=500.;                         // find minum 
    cz1[i]=0;
    for(j=0;j<n30;j++){
      xa=adx[i]-stx[j]; xd=ady[i]-sty[j];
      rr=sqrt(xa*xa+xd*xd);
      if(rr<r){ r=rr; cz1[i]=j; czr1[i]=r; }
    }
    r=500.;                         // find 2nd minum
    cz2[i]=0;
    for(j=0;j<n30;j++){
      xa=adx[i]-stx[j]; xd=ady[i]-sty[j];
      rr=sqrt(xa*xa+xd*xd);
      if(rr<r && rr!=czr1[i]){ r=rr; cz2[i]=j; czr2[i]=r; }
    }
    if(cz1[i]){ m++; w[m]=czr1[i]*10.; }
    if(cz2[i]){ m++; w[m]=czr2[i]*10.; }
  }
  white_black(w,m,1,&peak,&s);      // use 1st,2nd minum to solve
  peak*=0.1;
  s=3.;
  m=0;
  for(i=0;i<n30;i++){
    if(cz1[i]==0 && cz2[i]==0)continue;
l70:
    if(cz1[i]==0){
      r=czr2[i]-peak; if(r<0.)r=-r;
      if(r>s)continue;
      j=cz2[i];
      m++;
      czr1[m]=adx[i]-stx[j];
      czr2[m]=ady[i]-sty[j];
      continue;
    }
    if(cz2[i]==0){
      r=czr1[i]-peak; if(r<0.)r=-r;
      if(r>s)continue;
      j=cz1[i];
      m++;
      czr1[m]=adx[i]-stx[j];
      czr2[m]=ady[i]-sty[j];
      continue;
    }
    xa=czr1[i]-peak; if(xa<0.)xa=-xa;
    xd=czr2[i]-peak; if(xd<0.)xd=-xd;
    if(xa>xd)cz1[i]=0;
    if(xd>xa)cz2[i]=0;
    goto l70;
  }
  if(m<5 && ip==0){
    ip=1; goto l5;
  }
  xa=xmedian(czr1,m);
  xd=xmedian(czr2,m);
  s=-sqrt(xa*xa+xd*xd)*a8[0]*10800/pi;
  a8[6]+=xa*a8[0]/cos(a8[7]); 
  a8[7]-=xd*a8[0];                   // BOK is -
}

#define n80 80
#define n1600 n80*n80/4
int oa[n1600],ob[n1600],oc[n1600],od[n1600];
runnum()
{
  int i,j,k=0,m=2,l;
  for(i=0;i<n80;i+=m)for(j=0;j<n80;j+=m)
     { oa[k]=i; ob[k]=j; oc[k]=i+j; od[k]=k++; }
  for(i=0;i<k-1;i++)for(j=i+1;j<k;j++)if(oc[i]>oc[j]){
    l=oa[i]; oa[i]=oa[j]; oa[j]=l;
    l=ob[i]; ob[i]=ob[j]; ob[j]=l;
    l=oc[i]; oc[i]=oc[j]; oc[j]=l;
    l=od[i]; od[i]=od[j]; od[j]=l;
  }  
  return(k);
}

int oi[4]={1,1,-1,-1};
int oj[4]={1,-1,1,-1};
main(ac,av)
int ac; char *av[];
{
  int  i,j,k;
  double x,y,z;
  char a[80],c;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  if(ac<2){ 
            printf("\n\t  ****** auto find coordination in 80arcmin\n");
            printf("\n\tusage: coord63 e*_?.fit\n\n");
            printf("\n\tbefore run: getcoord\n");
            printf("\n\tafter  run: getcoord\n\n");
            exit(0);
          }
  strcpy(f1,av[1]);
  k=strlen(f1); c=k-5; if(c<0)c=0; j=0; for(i=c;i<k;i++)if(f1[i]=='.')j=i;  
  if(j==0) strcat(f1,".fit");
  fp=fopen(f1,"rb"); if(fp==0){ printf("\t%s file not found!\n",f1); exit(0); }
  fread(head,72,80,fp);
  k=indexpos(head,"NAXIS1  ",72);  sscanf(&head[k][24],"%d",&n1); 
                                   sscanf(&head[k+1][24],"%d",&n2);
  k=indexpos(head,"END     ",72);
  if(k==72)fread(map,36,72,fp);
//  check itype
  i=indexpos(head,"A81     ",72);
  itype=1;     if(i==72)itype=0;          // not found A81
  if(itype==1 && ac>2)itype=2;
  if(itype==1){ printf("\tcoordinating already done !\n"); exit(0); }
  getpar();                               // get s0,iy,im,id,ut,w_de,phi
  fread(map,n1*n2,4,fp); swap4(map,n1*n2*4); 
  fclose(fp);                             // for skyadu, seeing only

  getstar(&nstar);
  onum=runnum();
  for(i=0;i<onum;i++){
    printf("."); fflush(stdout);
    for(j=0;j<4;j++){
      dra=oa[i]*oi[j];  dde=ob[i]*oj[j];
      if(main_job())goto l999;
    }
  }
l999:
  if(i==onum){ printf(" ********* Fail **********\n"); exit(0); }    

  xytoad(a8,b8);
  xa=n1/2.; xd=n2/2.;
  xi=a8[0]*xa+a8[2]*xd+a8[4];
  xn=a8[1]*xa+a8[3]*xd+a8[5];
  astand(a8[6],a8[7],xi,xn,&xa,&xd);
  a_c=xa/cx; d_c=xd/cy;
  sky=0;
  sky_seeing(map,&sky,&skyrms,&seeing);
  put_a8();
  put_xmass();
  fp=fopen(f1,"rb+"); fwrite(head,72,80,fp); fclose(fp);

  oldac=(a8[6]-oldac)/cy*60+dra;
  olddc=(a8[7]-olddc)/cy*60+dde;
  printf("shift:%6.1lf%6.1lf   (arcmin)\n",oldac,olddc);
  fp=fopen("shift.bok","w"); 
  fprintf(fp,"%6.1lf%6.1lf\n",oldac,olddc); fclose(fp); 
  printf("\n\t**********  ok!  shift.bok  updated !\n");
}

sky_seeing(map,sky,skyrms,seeing)
float map[n2][n1];
double *sky,*skyrms,*seeing;
{
  int ix,iy, i,j,k,m, b[113];
  short d[300*300];
  float z,s1,s2;
  if(*sky==0.){ m=0; 
    for(ix=n1/4;ix<n1;ix+=n1/2)for(iy=n1/4;iy<n1;iy+=n1/2){
    k=0;for(i=ix-150;i<ix+150;i++)for(j=iy-150;j<iy+150;j++)d[k++]=map[i][j]/2.;
      white_black(d,1,k,&z,&s1);  if(z==0.)m++; 
      *sky+=z;  *skyrms+=s1;
    } *sky/=2.; *skyrms/=2.;      if(m){ *sky*=4.;  *skyrms*=4.;}
  }
  for(m=0;m<nstar;m++){
    ix=starx[m]+0.5; iy=stary[m]+0.5;
    for(j=0,i=ix-14;i<=ix+14;i++,j+=4){
    z=0.; for(k=-2;k<=2;k++)z+=map[iy+k][i]-*sky; b[j]=z; }
    for(j=0;j<112;j+=4)b[j+2]=(b[j]+b[j+4])/2.+0.5;
    for(j=0;j<112;j+=2)b[j+1]=(b[j]+b[j+2])/2.+0.5;
    for(j=k=0;j<112;j++)if(b[j]<0){b[j]=0; k++;} if(k>110)continue;
    histat(b,&z,&s1,112);
    for(j=0,i=iy-14;i<=iy+14;i++,j+=4){
    z=0.; for(k=-2;k<=2;k++)z+=map[i][ix+k]-*sky; b[j]=z; }
    for(j=0;j<112;j+=4)b[j+2]=(b[j]+b[j+4])/2.+0.5;
    for(j=0;j<112;j+=2)b[j+1]=(b[j]+b[j+2])/2.+0.5;
    for(j=k=0;j<112;j++)if(b[j]<0){b[j]=0; k++;} if(k>110)continue;
    histat(b,&z,&s2,112);
    d[m]=(s1+s2)/8.*2.355*100.+0.5;          // expand 100
  }
  k=0; for(i=0;i<m;i++)if(d[i]>200 && d[i]<1200)d[k++]=d[i];
  if(k<m/4)k=m; 
  white_black(d,1,k,&z,&s1); z*=0.01;        // shrink 100
  *seeing=z*0.45;
  printf("sky:%8.2lf  seeing:%6.2lf   ",*sky,*seeing);
}

put_a8()      // 49-58
{
  int i,j,k;
  j=32; k=33;
  toms2(a_c,c1,1); toms2(d_c,c2,0);
//  sprintf(&head[k++],"SKYADU  =         %12.2lf / (per pixel)",sky);
  sprintf(&head[k++],"SEEING  =         %12.2lf / (arcsec)",seeing);
  sprintf(&head[k++],"A81     = %20.12le / 6 plate coef.",a8[0]);
  sprintf(&head[k++],"A82     = %20.12le / matched star:%6d",a8[1],match);
  sprintf(&head[k++],"A83     = %20.12le / RMS (arcsec):%6.2lf",a8[2],rms);
  sprintf(&head[k++],"A84     = %20.12le / total ucac4: %6d",a8[3],nu4);
  sprintf(&head[k++],"A85     = %20.12le /",a8[4]);
  sprintf(&head[k++],"A86     = %20.12le /",a8[5]);
  sprintf(&head[k++],"A87     = %20.12le / p_c (2000.0) %s",a8[6],c1);
  sprintf(&head[k++],"A88     = %20.12le / in rad.      %s",a8[7],c2);
  sprintf(&head[5][49],"(2000.0)  #%c CCD real_center:",head[7][29]);
  sprintf(&head[6][52],"%s %s",c1,c2);
  astprs2(a_c,d_c,2000.,&xa,&xd,1950.);
  galactic(xa*cx,xd*cy,&xi,&xn);
  sprintf(&head[j++][56],"l_gal = %9.2lf",xi);
  sprintf(&head[j++][56],"b_gal = %9.2lf",xn);
  redden(xi,xn,&xa);
  sprintf(&head[k++],"EXTINCT = %20.3lf / BH Bmag, EXTINCTION = 4*E(B-V)",xa);
}

galactic(alpha,delta,xl,xb)
double alpha,delta,*xl,*xb;
{
  double a0,theta,xl0,x1,x2;
  a0=282.25*cy;
  theta=62.6*cy;
  xl0=33.0*cy;
  x1=cos(delta)*cos(alpha-a0);
  x2=cos(delta)*sin(alpha-a0)*cos(theta)+sin(delta)*sin(theta);
  *xl=atan2(x2,x1)+xl0;
  if(*xl<0.)*xl+=2.0*pi;
  *xb=asin(sin(delta)*cos(theta)-cos(delta)*sin(alpha-a0)*sin(theta));
  *xl/=cy;  *xb/=cy;
}

double xmass(angle,delta)
double angle,delta;
{
  double x,z;
  x=sin(delta)*sphi+cos(delta)*cos(angle)*cphi;
  x=1./x-1.;
  z=1.+x-x*(0.0018167+x*(0.002875+x*0.0008083));
  return(z);
}

put_xmass()                                    // 15,16,17,64
{
  int i,j,k;
  double xk,x,xmm,xmb,xme;
  j=(iy+((im-1)*30.4+id)/365.)*10.+0.5;
  epoch=j*0.1;
  astprs2(a_c,d_c,2000.,&xa,&xd,epoch);
  toms2(xa,c1,1);
  toms2(xd,c2,0);
  k=indexpos(head,"RA      ",72);
  sprintf(&head[k][10],"'     %s'",c1);
  sprintf(&head[k][49],"(%6.1lf)",epoch);
  k=indexpos(head,"EPOCH   ",72);
  if(k!=72)sprintf(&head[k][23]," %6.1lf",epoch); head[k][10]=32;
  k=indexpos(head,"DEC     ",72);
  sprintf(&head[k][10],"'      %s'",c2);
  sprintf(&head[k][49],"(%6.1lf)",epoch);
  ha=s0-xa; while(ha>=24.)ha-=24.;
            while(ha<0.)  ha+=24.;
  toms2(ha,c1,1);
  k=indexpos(head,"HA      ",72);
  sprintf(&head[k][10],"'     %s'",c1);
  xmm=xmass(ha*cx,xd*cy);                            // middle time
  k=indexpos(head,"EXPTIME ",72);
  if(k==72)k=indexpos(head,"EXPOSURE",72);
  sscanf(&head[k][19],"%lf",&xk);                     // exp time
  xmb=xmass((ha-xk/7200.)*cx,xd*cy);                 // begin time
  xme=xmass((ha+xk/7200.)*cx,xd*cy);                 // end time
  x=(xmb+4.*xmm+xme)/6.;
  k=indexpos(head,"A81     ",72)+9;
  sprintf(&head[k],"AIRMASS = %20.3lf /",x);
  for(j=0;j<72;j++)for(i=0;i<80;i++)if(head[j][i]==0)head[j][i]=32;
}

//c this subroutine written by burstein in FORTRAN.
redden(al,b,red)
double al,b,*red;
{
  int ired[1200],ihi[201],ilin,kz,kq,iebv,kw,kx,ky;
  float xrad,alin,bb,arec,alc,bmv,ahi,abv;
  FILE *fp10;
  int  ip11=451200;
  int  ip12=451200;
  int  ip13=168840;

  xrad=57.2958;
  alin=al/0.3+0.5;
  ilin=alin+0.51;
  bb=b; if(bb<0.)bb=-bb;
  if(bb<10.)return(-0.99);
  fp10=fopen("/UCAC4/burstein.red","rb");
  if(fp10==0){ printf("burstein.red not found !\n"); exit(0); }
  if(b>0.)goto l18;
  if(b+62.<0.)goto l13;
  arec=-(b+10.)/0.6+1.;
  kz=arec+0.51;
  fseek(fp10,(kz-1)*4800,0); fread(ired,4,1200,fp10);   
  kq=kz-1;
  iebv=ired[ilin-1];
  goto l19;
l13:
  alc=al/xrad;
  arec=101.+sin(alc)*(90.+b)/0.3;
  alin=101.+cos(alc)*(90.+b)/0.3;
  kw=arec+0.51;
  ilin=alin+0.51;
  fseek(fp10,(kw-1)*804+ip11+ip12+ip13,0); fread(ihi,4,201,fp10);
  ahi=ihi[ilin-1];
  bmv=-0.0372 + 0.357*ahi/10000.;
  iebv=bmv*1000.+0.5;
  kq=kw-1;
  goto l19;
l18:
  if(b-62.>0)goto l16;
  arec=(b-10.)/0.6+1.;
  ky=arec+0.51;
  fseek(fp10,(ky-1)*4800+ip11,0); fread(ired,4,1200,fp10);
  kq=ky-1;
  iebv=ired[ilin-1];
  goto l19;
l16:
  alc=al/xrad;
  arec = 101. + sin(alc)*(90.-b)/0.3;
  alin = 101. + cos(alc)*(90.-b)/0.3;
  kx=arec+0.51;
  ilin=alin+0.51;
  fseek(fp10,(kx-1)*804+ip11+ip12,0); fread(ihi,4,201,fp10);
  ahi=ihi[ilin-1];
  bmv = -0.0372 + 0.357*ahi/10000.;
  iebv=bmv*1000.+0.5;
  kq=kx-1;
l19:
  fclose(fp10);
  abv=iebv;
  *red=abv*4./1000. + 0.005;
}

